unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    ImageList1: TImageList;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TreeView1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    CurrentNode : TTreeNode;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to TreeView1.Items.Count - 1 do
    begin
      TreeView1.Items.Item[i].StateIndex := 2;
    end;
  TreeView1.Items.Item[0].Expand(True);
end;

procedure TForm1.TreeView1Click(Sender: TObject);
  procedure SelectAllChild(Root : TTreeNode ; State : Integer);
  var
    i : Integer;
  begin
    for i := 0 to Root.Count - 1 do
      begin
        Root.Item[i].StateIndex := State;
        if Root.Item[i].Count > 0 then
          SelectAllChild(Root.Item[i],State)
      end;
  end;
var
  i : Integer;
  x : TTreeNode;
  AllChildSelected : Boolean;
begin
  if CurrentNode.StateIndex = 3 then
    CurrentNode.StateIndex := 2
  else
    CurrentNode.StateIndex := 3;
// W
  x := CurrentNode.Parent;
  while x <> NIL do
    begin
      AllChildSelected := True;
      for i := 0 to x.Count - 1 do
        begin
          if x.Item[i].StateIndex = 2 then
            begin
              AllChildSelected := False;
              Break;
            end;
        end;
      if AllChildSelected then
        x.StateIndex := 3
      else
        x.StateIndex := 2;
      x := x.Parent;
    end;
// U
  SelectAllChild(CurrentNode,CurrentNode.StateIndex);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage(InttoStr(TreeView1.Selected.AbsoluteIndex));
end;

procedure TForm1.TreeView1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If TTreeView(Sender).GetNodeAt(X,Y) <> NIL then
    begin
      CurrentNode :=TTreeView(Sender).GetNodeAt(X,Y);
    end
end;

end.
